[![License][license-image]][license-url]
[![NPM version][npm-version-image]][npm-version-url]
[![All Contributors][all-contributors-image]](#contributors)
[![code style: prettier][prettier-image]][prettier-url]
[![config: knuckle][knuckle-image]][knuckle-url]

[license-image]: https://img.shields.io/github/license/GuillaumeAmat/knuckle.svg?style=flat-square
[license-url]: https://github.com/GuillaumeAmat/knuckle/blob/master/LICENSE
[npm-version-image]: https://img.shields.io/npm/v/knuckle.svg?style=flat-square&colorB=yellow
[npm-version-url]: https://npm.im/knuckle
[all-contributors-image]: https://img.shields.io/badge/all_contributors-3-orange.svg?style=flat-square
[prettier-image]: https://img.shields.io/badge/code_style-prettier-ff69b4.svg?style=flat-square
[prettier-url]: https://prettier.io
[knuckle-image]: https://img.shields.io/badge/config-knuckle-ff5c00.svg?style=flat-square
[knuckle-url]: https://github.com/GuillaumeAmat/knuckle
[eslint-url]: https://eslint.org
[cosmiconfig-url]: https://github.com/davidtheclark/cosmiconfig
[stylelint-url]: https://github.com/stylelint/stylelint
[jest-url]: https://github.com/facebook/jest

# 👊 Knuckle

![Demo](demo.gif)

With Knuckle, _Don't duplicate code_ becomes _Don't duplicate configuration_.

It bootstraps for you configurations and dependencies of your projects dev tools. It also removes the pain of upgrading the configurations and versions over time.

More informations in the [Usage guide](./docs/Usage_guide.md) and the [FAQ](./docs/FAQ.md).

## Available tools

For now, the available tools are:

- [Prettier](config/prettier)
- [ESLint](config/eslint)
- [TSLint](config/tslint)
- [Commitlint](config/commitlint)
- [Lint-Staged](config/lint-staged)
- [Husky](config/husky)

But many others will follow (PRs are welcome by the way ;) ):

- [Stylelint][stylelint-url]
- [Jest][jest-url]
- Etc.

## Badge

[![config: knuckle](https://img.shields.io/badge/config-knuckle-ff5c00.svg?style=flat-square)](https://github.com/GuillaumeAmat/knuckle)

```
[![config: knuckle](https://img.shields.io/badge/config-knuckle-ff5c00.svg?style=flat-square)](https://github.com/GuillaumeAmat/knuckle)
```

## Contributors

Thanks goes to these people :

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore -->
| [<img src="https://avatars3.githubusercontent.com/u/31624379?v=4" width="100px;"/><br /><sub><b>François Rosato</b></sub>](https://github.com/frosato-ekino)<br />[🐛](https://github.com/knuckle/knuckle/issues?q=author%3Afrosato-ekino "Bug reports") [💻](https://github.com/knuckle/knuckle/commits?author=frosato-ekino "Code") [📖](https://github.com/knuckle/knuckle/commits?author=frosato-ekino "Documentation") [💡](#example-frosato-ekino "Examples") [🤔](#ideas-frosato-ekino "Ideas, Planning, & Feedback") [👀](#review-frosato-ekino "Reviewed Pull Requests") [⚠️](https://github.com/knuckle/knuckle/commits?author=frosato-ekino "Tests") [🔧](#tool-frosato-ekino "Tools") [✅](#tutorial-frosato-ekino "Tutorials") | [<img src="https://avatars3.githubusercontent.com/u/1179174?v=4" width="100px;"/><br /><sub><b>Guillaume AMAT</b></sub>](https://github.com/GuillaumeAmat)<br />[🐛](https://github.com/knuckle/knuckle/issues?q=author%3AGuillaumeAmat "Bug reports") [💻](https://github.com/knuckle/knuckle/commits?author=GuillaumeAmat "Code") [📖](https://github.com/knuckle/knuckle/commits?author=GuillaumeAmat "Documentation") [💡](#example-GuillaumeAmat "Examples") [🤔](#ideas-GuillaumeAmat "Ideas, Planning, & Feedback") [📦](#platform-GuillaumeAmat "Packaging/porting to new platform") [👀](#review-GuillaumeAmat "Reviewed Pull Requests") [📢](#talk-GuillaumeAmat "Talks") [⚠️](https://github.com/knuckle/knuckle/commits?author=GuillaumeAmat "Tests") [🔧](#tool-GuillaumeAmat "Tools") [✅](#tutorial-GuillaumeAmat "Tutorials") | [<img src="https://avatars1.githubusercontent.com/u/6979207?v=4" width="100px;"/><br /><sub><b>Julien Viala</b></sub>](https://github.com/mr-wildcard)<br />[🤔](#ideas-mr-wildcard "Ideas, Planning, & Feedback") |
| :---: | :---: | :---: |

<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the
[all-contributors](https://github.com/kentcdodds/all-contributors)
specification. Contributions of any kind are welcome!
